{% extends 'basenew.html' %}
{% load static %}


{% block title %}Blog{% endblock %}
{% block jumbotitle %}My First Load Balancer &#x1f310;{% endblock %}
{% block jumbocontent %}{% endblock %}
{% block stylecss %}<link rel="stylesheet" href="{% static 'blogcss.css' %}">{% endblock %}

{% block content %}
    <div class="row justify-content-center">
        <div class="col-10">
            <div id="blog">
                <h3>APA ITU LOAD BALANCER?</h3>
                <p>Menurut <i>http://bit.ly/2OC5Zf3</i>, <b>load balancing</b> memiliki arti pendistribusian traffic jaringan yang masuk melalui sekelompok backend server, juga dikenal sebagai "serverfarm" atau "serverpool". Load balancer berperan sebagai "traffic cop" atau penjaga yang akan routing request client ke server - server dengan cara yang memaksimalkan kecepatan dan memastikan bahwa tidak ada satu server yang bekerja terlalu keras sehingga dapat menurunkan kinerja.</p>
            </div>
            <div id="blog">
                <h3>MENGAPA PERLU ADA LOAD BALANCER?</h3>
                <p>Load Balancer dibutuhkan jika suatu website menerima banyak request sehingga bisa memilah-milah client ke server - server yang tersedia sehingga tidak terjadi overload dan traffic. Load balancer juga penting digunakan untuk mengkonfigurasi jika ada satu server yang down, maka client secara otomatis akan diteruskan ke server yang berjalan.</p>
            </div>
            <div id="blog">
                <h3>BAGAIMANA CARA KERJA LOAD BALANCER?</h3>
                <p>Terdapat 3 cara kerja load balancer yang umum digunakan saat ini, yaitu: <br><b>1. Round-robin</b>
                    <br>==> Secara default load balancer akan meneruskan client ke server yang berbeda. Misal terdapat 2 server yang berjalan, maka request pertama akan ke server 1, request kedua akan ke server 2, request ketiga akan ke server 1 dan begitu seterusnya.
                    <br><br><b>2. Least-connected</b>
                    <br>==> Jika ada suatu request dari client, maka load balancer akan mencari server yang paling sedikit koneksinya dan request akan diteruskan ke server tersebut.
                    <br><br><b>3. IP-Hash</b>
                    <br>==> Tidak seperti kedua method diatas yang bisa meneruskan client yang sama ke server yang berbeda, method IP-Hash memastikan client yang sama (dilihat dari IP Address) tetap pada server yang sama. Jadi jika ada request dengan suatu IP Address ke server 1, maka walaupun berulang di reload, request dengan IP Address tersebut akan selalu ke server 1. Method ini berguna jika suatu website memanfaatkan Cookies dan Session (seperti pada story sebelumnya).
                    <br><br><i>(http://bit.ly/2syQvjm)</i></p>
            </div>
            <div id="blog">
                <h3>TUTORIAL KONFIGURASI LOADBALANCER</h3>
                <p><b>PART 1: INSTALASI</b>
                    <br>Saya menggunakan NGINX. Instalasinya tidak sulit, yaitu dengan download "nginx/Windows-1.17.6" dari <i>http://nginx.org/en/download.html</i> dan unzip di folder project.
                    <br><br><b>PART 2: KONFIGURASI</b>
                    <br>1. Masuk ke folder NGINX yang telah diunzip kemudian ke folder conf kemudian buka file 'nginx.conf'
                    <br>2. Ubah isi bagian 'server {' dan tambahkan 'upstream' menjadi:
                    <br><br><img src="{%  static 'blog4.png' %}">
                    <br><i style="font-size: medium">(nama 'backendweb' dapat diganti bebas tetapi disesuaikan di dalam proxy_pass dan upstreamnya</i>
                    <br><br>3. Di urls.py disetting pada urlspatterns, misal 'path('',views.index)'
                    <br><br><img src="{%  static 'blog3.png' %}">
                    <br><br>4. Di views.py dapat return render HTMl, tetapi untuk memperlihatkan kita sedang memakai server yang mana (sekaligus untuk pengujian) saya menuliskan 'return HttpResponse("request port: " + request.META['SERVER_PORT'])'
                    <br><br><img src="{%  static 'blog2.png' %}">
                    <br><br>5. Kembali ke folder NGINX kemudian run file 'nginx.exe'
                    <br>6. Jangan lupa "ALLOWED_HOSTS = ['*']" pada settings.py project
                    <br><br><img src="{%  static 'blog1.png' %}">
                    <br><br>7. Lakukan runserver di CMD dengan command 'python manage.py runserver' untuk localhost 8000 dan di CMD lain 'python manage.py runserver 9000' untuk localhost 9000
                    <br><br><img src="{%  static 'blog6.png' %}">
                    <br><br><img src="{%  static 'blog5.png' %}">
                    <br><br>Dikarenakan tidak mendefinisikan settings method loadbalancer yang digunakan pada nginx.conf, maka secara default menggunakan method Round-robin.
                </p>
            </div>
            <div id="blog">
                <h3>PENGUJIAN TERHADAP LOAD BALANCER</h3>
                <p>Saya melakukan empat kali pengujian, yaitu:
                    <br>1. Melakukan 'python manage.py runserver' dan 'python manage.py runserver:9000' serta run nginx.exe
                    <br>==> Seperti yang diharapkan, kedua server (localhost:8000 dan localhost:9000) dapat diakses keduanya dengan mudah. Saya hanya menuliskan 'localhost' di kolom URL browser dan setiap reload memberikan server port yang berbeda.
                    <br><br>2. Melakukan 'python manage.py runserver' dan 'python manage.py runserver:9000' tetapi tidak run nginx.exe
                    <br>==> Ternyata 'localhost:8000' dan 'localhost:9000' masing - masing dapat diakses tetapi tidak bisa hanya mengakses 'localhost' karena error "This site can’t be reached. localhost refused to connect."
                    <br><br>3. Melakukan 'python manage.py runserver' dan run nginx.exe tetapi tidak 'python manage.py runserver:9000'
                    <br>==> 'localhost:8000' dan 'localhost' dapat diakses tetapi tidak dengan 'localhost:9000' sehingga walaupun reload berkali-kali 'localhost' akan terus menampilkan request 8000
                    <br><br>4. Melakukan 'python manage.py runserver:9000' dan run nginx.exe tetapi tidak 'python manage.py runserver'
                    <br>==> 'localhost:9000' dan 'localhost' dapat diakses tetapi tidak dengan 'localhost:8000' sehingga walaupun reload berkali-kali 'localhost' akan terus menampilkan request 9000</p>
            </div>
        </div>
    </div>
{% endblock %}
{% block script %}{% endblock %}